var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { spacing, commonColors } from '@workday/canvas-kit-react-core';
import styled from '@emotion/styled';
import { useTab } from './Tabs';
var TabsListContainer = styled('div')({
    display: 'inline-block',
    position: 'relative',
    width: "100%",
    borderBottom: "1px solid " + commonColors.divider,
});
var TabsListInnerContainer = styled('div')({
    display: "flex",
    margin: "0 " + spacing.m,
});
var TabList = function (_a) {
    var children = _a.children, elemProps = __rest(_a, ["children"]);
    var tabsListRef = React.useRef(null);
    var _b = useTab(), setIntentTab = _b.setIntentTab, programmaticFocusRef = _b.programmaticFocusRef;
    var onKeyDown = function (event) {
        switch (event.key) {
            case 'ArrowLeft':
            case 'Left':
                setIntentTab('previous');
                break;
            case 'ArrowRight':
            case 'Right':
                setIntentTab('next');
                break;
            case 'Home':
                setIntentTab('first');
                break;
            case 'End':
                setIntentTab('last');
                break;
            default:
                break;
        }
    };
    var resetProgrammaticFocus = function () {
        programmaticFocusRef.current = false;
    };
    return (React.createElement(TabsListContainer, { ref: tabsListRef },
        React.createElement(TabsListInnerContainer, __assign({ role: "tablist", onKeyDown: onKeyDown, onFocus: resetProgrammaticFocus }, elemProps), children)));
};
export default TabList;
